/* PROGRAM NO. 2 */

/* WRITE A PROGRAM TO IMPLEMENT THE MIDPOINT LINE ALGORITHM TO GENERATE A
	 LINE WITH ANY SLOPE AND THICKNESS.  IMPLEMENT THE POLYLINE COMMAND USING
	 THIS ALGORITHM AS A ROUTINE THAT DISPLAYS THE SET OF STRAIGHT LINES
	 BETWEEN THE 'N' INPUT POINTS.  FOR N=1, THE ROUTINE DISPLAYS A
	 SINGLE POINT */

#include<graphics.h>
#include<conio.h>
#include<stdio.h>


void bline(int x1,int y1, int x2, int y2,int t)
{
	int x,y,p,dx,dy,i;
	dx=abs(x2-x1);
	dy= abs(y2-y1);
	if(abs(dx)>=abs(dy))
	{
		if(x1>x2)
		{
			x=x2;
			x2=x1;
			x1=x;
			y=y2;
			y2=y1;
			y1=y;
		}
		else
		{
			x=x1;
			y=y1;
		}
		p=2*dy-dx;
		while(x<=x2)
		{
			for(i=y-t/2;i<=y+t/2;i++)
			putpixel(x,i,MAGENTA);
			delay(100);
			if(p>=0)
			{
				x++;
				if(y2>y1) y++;
				else y--;
				p+=2*(dy-dx);
			}
			else
			{
				x++;
				p+=2*dy;
			}
		}
	}
	else
	{
		if(y1>y2)
		{
			x=x2;
			x2=x1;
			x1=x;
			y=y2;
			y2=y1;
			y1=y;
		}
		else
		{
			x=x1;
			y=y1;
		}
		p=2*dx-dy;
		while(y<=y2)
		{
			for(i=x-t/2;i<=x+t/2;i++)
			putpixel(i,y,MAGENTA);
			delay(100);
			if(p>=0)
			{
				y++;
				if(x2>x1) x++;
				else x--;
				p+=2*(dx-dy);
			}
			else
			{
				y++;
				p+=2*dx;
			}
		}
	}
}


void main()
{
	int gd=DETECT,gm,x[20],y[20],i,t,n;
	printf("Enter the number of points\n");
	scanf("%d",&n);
	printf("\nEnter the thickness of the line\n");
	scanf("%d",&t);
	printf("\nEnter the co-ordinates of the line\n");
	for(i=0;i<n;i++)
	scanf("%d %d",&x[i],&y[i]);
	initgraph(&gd,&gm," ");
	if(n>1)
	{
		for(i=0;i<n-1;i++)
		bline(x[i],y[i],x[i+1],y[i+1],t);
		getch();
	}
	else
		bline(x[0],y[0],x[0],y[0],t);
		getch();
	closegraph();
}
