/* PROGRAM NO.6 */

/* PROGRAM TO CREATE A HOUSE LIKE FIGURE USING BUILD-IN LINE
	 COMMAND AND TO PERFORM
	 I>   SCALING WITH REFERENCE TO THE ORIGIN
	 II>  SCALING WITH REFERENCETO AN ARBITRARY POINT
	 III> REFLECTION ABOUT THE LINE Y=MX+C   */

#include<stdio.h>
#include<graphics.h>
#include<math.h>

int x1,y1,x2,y2,x3,y3,x4,y4,x5,y5;
int scale(int x,int y,float s);
void xchg(int *x,int *y);

void main()
{
  int gm,gd=DETECT,choice;
  initgraph(&gd,&gm," ");
  init();
  draw();
  do
  {
    gotoxy(1,1);
    printf("\nMenu");
		printf("\n1:Scaling w.r.t origin");
		printf("\n2:Scaling w.r.t an arbitrary point p");
		printf("\n3:Reflection about the line y=mx+c");
		printf("\n4:Exit\n");
		printf("\nEnter your choice ");
		scanf("%d",&choice);
		switch(choice)
		{
			case 1: cleardevice();
							init();
							scale(0,0,1.5);
							draw();
							break;

			case 2: cleardevice();
							init();
							scale(20,20,1.5);
							draw();
							break;

			case 3: cleardevice();
							init();
							reflect();
							draw();
							break;

			default: exit(0);
		}
	}
	while(choice!=4);
	getch();
	closegraph();
}

int draw()
{
	rectangle(x1,y1,x2,y2);
	setfillstyle(2,BROWN);
	floodfill((x1+x2)/2,(y1+y2)/2,WHITE);
	line(x4,y4,x5,y5);
	line(x4,y4,x3,y3);
	line(x3,y3,x5,y5);
	setfillstyle(7,4);
	floodfill((x3+x4+x5)/3,(y3+y4+y5)/3,WHITE);
	getch();
	return(0);
}

int scale(int x,int y,float s)
{
	x1=x1*s+x*(1-s);
	x2=x2*s+x*(1-s);
	x3=x3*s+x*(1-s);
	x4=x4*s+x*(1-s);
	x5=x5*s+x*(1-s);
	y1=y1*s+y*(1-s);
	y2=y2*s+y*(1-s);
	y3=y3*s+y*(1-s);
	y4=y4*s+y*(1-s);
	y5=y5*s+y*(1-s);
	return(0);
}

int reflect()
{
	xchg(&x1,&y1);
	xchg(&x2,&y2);
	xchg(&x3,&y3);
	xchg(&x4,&y4);
	xchg(&x5,&y5);
	return(0);
}

int init()
{
	x1=250,y1=100,x2=350,y2=220;
	x3=(x2-x1)/2+x1;
	y3=y1-40;
	x4=x1-20;
	x5=x2+20;
	y4=y5=y1;
	return(0);
}

void xchg(int *x,int *y)
{
	int temp;
	temp=*x;
	*x=*y;
	*y=temp;
}
