/* PROGRAM NO. 8 */

/* WRITE A PROGRAM TO IMPLEMENT BEZIER CURVER FOR THE
	 GIVEN SET OF CONTROL POINTS */

#include <graphics.h>
#include <stdio.h>
#include <conio.h>

void main()
{
	int gd = DETECT,gm;
	double numsteps,i,t;
	float stepsize;
	int x0,y0,x1,y1,x2,y2,x3,y3,x,y;
	int ax,ay,bx,by,cx,cy,dx,dy;

	initgraph (&gd,&gm," ");

	x0 = 50;
	y0 = 180;

	x1 = 250;
	y1 = 10;

	x2 = 400;
	y2 = 300;

	x3 = 500;
	y3 = 50;


	ax = -x0+3*x1+(-3*x2)+x3;
	ay = -y0+3*y1+(-3*y2)+y3;

	bx = 3*x0+(-6*x1)+3*x2;
	by = 3*y0+(-6*y1)+3*y2;

	cx = -3*x0+3*x1;
	cy = -3*y0+3*y1;

	dx = x0;
	dy = y0;

	setcolor (MAGENTA);

	numsteps = 100;
	stepsize = 1.0/(double)numsteps;

	moveto (dx,dy);

	for (i=1;i<numsteps;i++)
	{
		t = stepsize * (double) i;

		x = ax*(t*t*t)+bx*(t*t)+cx*t+dx;
		y = ay*(t*t*t)+by*(t*t)+cy*t+dy;

		lineto (x,y);
	}

	setcolor(YELLOW);
	line (50,180,250,10);
	line (400,300,500,50);
	line (50,180,400,300);
	line (250,10,500,50);
	outtextxy (50,120,"Tangent1");
	outtextxy (480,120,"Tangent2");
	setcolor(MAGENTA);
	outtextxy (250,120,"Cubic Bazier Curve");

	getch();
	closegraph();
}